#include "APO.h"
/*
  Call: AnalyzeScGoals ScGoalsfile configfile
  Purpose: Analyze the scientific goals specified in ScGoalsfile for the 
           instrument described in configfile.

	   The scientific goals file should be written as follows:
! alpha beta gamma(dB) dtheta(arcsec) lambda(mm)
1 1 10 8.295e-1 1
1 1 10 1.296e-1 1
etc...
           alma.getBSL_FWHM_ObsDur returns:
	          -the largest baseline length in bsl  
		  -the duration of observation required in obsdur
		  -the FWHM of the gaussian model distribution in fwhm
		  -the returned integer ok is null if iconfig is gt the 
		   number of lines in the scientific goals file


 */

Instrume alma;
Obs obs1;
Transf transf1;
Site Chaj;
Model mod1;
Configfile filei;

main(int argc, char **argv){

  int ok=1, iconfig=0;
  float obsdurmax, bsl, fwhm, obsdur;

  filei=argv[2];
  filei.read(&alma, &Chaj, &obs1, &mod1);

  obsdurmax=8.;
  printf("Analyze for obsdurmax =%f\n hour\n",obsdurmax);
  while(ok){
    printf("-----------------------------\n");
    ok=alma.getBSL_FWHM_ObsDur(obsdurmax, argv[1], iconfig, 
			    &bsl, &fwhm, &obsdur);
    iconfig++;
  }
}

