
#include "APO.h"
#include <string.h>

#define GRIDSZ0 5
#define NGRIDS0 8
#define NITER 100
#define FA0 0.04
#define FF0 100.
#define DPTACC0 1.0
#define NLOADMAX 4
#define NEWBSL 1250. 
#define NEWFWHM 1120.
#define NEWOBSDUR 6.
#define NEWDT 1.2
#define NEWHAMIN -3.
#define NEWDEC -10

APO vapo[NGRIDS0];
Instrume alma;
Obs obs1;
Transf transf1;
Site Chaj;
Grid vgrid[NGRIDS0];
Model mod1;
Configfile filei, fileo;
Padslist pads;

//----------------------------------------------------------------------
//  Parameters that are set in getArgs()
//----------------------------------------------------------------------
void getArgs(int argc, char **argv);		// get command-line arguments

char namei[MAXSTRING], nameo[MAXSTRING]; 
char padsfile[MAXSTRING], dir[MAXSTRING]; 

/*==========================================*/


void main(int argc, char **argv){


  int i,j,k,l,iter, natot, ngrids, nconf, nloaded;
  int test1,test2;
  char pause;
  float fa,dptacc,ff;
  float gridrmax, gridrmin, dmax,fwhm;
  float dec, hamin, dt,obsdur;
  float **traject;
  char *stdname="stdev.data",s[15];
  char *dotchar;
  char trajfile[MAXSTRING];
  time_t rtime;
  FILE *fp, *trajfp;
  float stdev,integr;

  printf("----Start of main------ \n");
  getArgs(argc, argv);

  rtime=time(NULL);
  if((fp=fopen(stdname,"w")) == NULL){
    printf("ERROR: cannot open file %s\n",stdname);
    exit(1);
  }

  filei=namei;
  fileo=nameo;
  filei.read(&alma, &Chaj, &obs1, &mod1);
  pads=padsfile;
  pads.read();
  pads.print();
  scanf("%c",&pause);

  alma.print();
  //alma.sort();
  //alma.print();
  //fileo.write(&alma, &Chaj, &obs1, &mod1);
  scanf("%c",&pause);
  //alma.print();
  //Chaj.print();

  natot=alma.getnatot();
  dmax=alma.getdmax();

  fwhm=mod1.getfwhm()/dmax;
  printf("fwhm=%f\n",fwhm);
 
  // if(fwhm>1){
  // if(fwhm<1.8) FA0/=(5*(pow(fwhm,1.4)-0.8));
  // else FA0/=(5*(pow(1.8,1.4)-0.8));
  //}
  printf("FA0=%f\n",FA0); 

  gridrmax=mod1.getdmax();
  gridrmin=mod1.getdmin();
  printf("gridrmax=%f\n",gridrmax)
;
  dmax=NEWBSL;
  gridrmax=NEWBSL;
  fwhm=NEWFWHM;
  alma.setvdmax(&dmax,1);
  mod1.set(fwhm, gridrmin, gridrmax);

  obs1.get(&dec, &hamin, &dt, &obsdur, &nconf);
  obsdur=NEWOBSDUR;
  dt=NEWDT;
  dec=NEWDEC;
  hamin=NEWHAMIN;
  obs1.set(dec, &hamin, dt, &obsdur, 1); 

  traject=matrix(2*(NITER+1),natot);
  strcpy(trajfile, nameo);
  dotchar=strchr(trajfile,'.');
  *dotchar='\0';
  strcat(trajfile,"_traj.data");
  printf("trajfile=%s\n",trajfile);
  scanf("%c",&pause);
  //sprintf(trajfile,"%s%s%d%s",dir,"array",iconfig+1,"_traj.data");
  alma.getpositions(traject[0], traject[1]);

  for(i=0;i<NGRIDS0;i++){
    vgrid[i].set(GRIDSZ0+i, gridrmin,gridrmax, &mod1);
    printf("grid %d set\n",i);
    vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
  }

  //transf1.setshadow(-73.);

  //correct(vapo,NGRIDS0,DPTACC,0);
  correct(vapo,NGRIDS0,DPTACC0);

  //fileo.write(&alma, &Chaj, &obs1, &mod1);
  //vapo[0].optimize(FA0,DPTACC);
  scanf("%c",&pause);
  for(i=0;i<NGRIDS0;i++) {
    stdev=vapo[i].getstdev();
    fprintf(fp,"%-9.2f ",stdev);
  }
  fprintf(fp,"\n");

  alma.freeants();

  for(k=0;k<NITER;k++) {
    printf("k=%d\n",k);
    fa=FA0/150;
    if(k>2) fa=FA0/70;
    if(k>3) fa=FA0/20;
    if(k>5) fa=FA0/8;
    if(k>7) fa=FA0/3;
    if(k>10) fa=FA0/1.5;
    if(k>13) fa=FA0;
    if(k>43) fa=FA0/1.2;
    if(k>NITER-3) fa=FA0/1.5;         

    dptacc=DPTACC0;
    if(k<10) dptacc=5*DPTACC0;
    if(k<20) dptacc=2*DPTACC0;

    ff=FF0/1.5;
    if(k==31) ff=FF0;
    if(k==37) ff=FF0;
    //if(k>40) ff=FF0/3.;
    if(k>40) ff=FF0/2.;
    if(k>43) ff=FF0/4.;
      
    ngrids=NGRIDS0;
    if(k==NITER/2){
      for(i=0;i<ngrids;i++){
	vgrid[i].set(GRIDSZ0+i+1, gridrmin,gridrmax, &mod1);
	printf("grid %d set\n",i);
	vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
      }
    }
    if(k==NITER-12){
      ngrids=NGRIDS0-2;
      for(i=0;i<ngrids;i++){
	vgrid[i].set(GRIDSZ0+i+4, gridrmin,gridrmax, &mod1);
	printf("grid %d set\n",i);
	vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
      }
    }
    if(k>16 && k<NITER-3 && k%3==1){
      nloaded=alma.loadants2pads(&pads, NLOADMAX, dmax, ff, 0);
      //	alma.print();
      //scanf("%c",&pause);
      if(nloaded>0){
	for(i=0;i<NGRIDS0;i++) 
	  vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
	//correct(vapo,NGRIDS0,DPTACC0);
      }
    }

    //if(k==40) alma.freeants();
    optimize(vapo,ngrids,fa,dptacc);
    alma.getpositions(traject[2*(k+1)], traject[2*(k+1)+1]);
    if(k<NITER-15) shake(vapo,ngrids,dptacc);


    for(i=0;i<ngrids;i++) {
      stdev=vapo[i].getstdev();
      fprintf(fp,"%-9.2f ",stdev);
    }
    fprintf(fp,"\n");
  }
  if((trajfp=fopen(trajfile,"w")) == NULL){
    printf("ERROR: cannot open file %s\n",trajfile);            
    exit(1);
  }
  for(i=0;i<natot;i++){
    for(j=0;j<NITER+1;j++) 
      fprintf(trajfp,"%-8.1f %-8.1f ",traject[2*j][i],traject[2*j+1][i]);
    fprintf(trajfp,"\n");
  }
  fclose(trajfp);
  fileo.write(&alma, &Chaj, &obs1, &mod1);
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
  fclose(fp);
}

//----------------------------------------------------------------------

void getArgs(int argc, char **argv)
{
  char tmp[MAXSTRING];

    if (argc <= 1) {				// no arguments
  	cerr << "Usage:\n\n"
	<< "  optimize [-d dir] [-i inputfile] [-o outputfile] [-p padsfile] \n\n"
	<< "  where:\n"
	<< "    inputfile       name of the configfile to be used as input\n"
	<< "    outputfile      name of the configfile to be used as output\n"
	<< "    padsfile        name of the file containing the pad locations\n"
	<< "    dir             directory where input file is read and output file written\n";
	exit(0);
    }
    int i = 1;
    while (i < argc) {				// read arguments
	if (!strcmp(argv[i], "-d")) {	      // -d option
	  sprintf(dir,"%s",argv[++i]);        // directory
	}
	else if (!strcmp(argv[i], "-i")) {	// -i option
	  sprintf(namei,"%s",argv[++i]);        // input file
	}
	else if (!strcmp(argv[i], "-o")) {	 // -o option
	  sprintf(nameo,"%s",argv[++i]);         // output file
	}
	else if (!strcmp(argv[i], "-p")) {	 // -p option
	  sprintf(padsfile,"%s",argv[++i]);         // pads file
	}
        else {					// illegal syntax
	    cerr << "Unrecognized option.\n";
	    exit(1);
	}
	i++;
    }
    if (strlen(nameo)==0 || strlen(namei)==0 ) {
	cerr << "-i and -o options must be specified\n";
	exit(1);
    }
    if (strlen(padsfile)==0 ) {
	cerr << "-p option must be specified\n";
	exit(1);
    }
    if (strlen(dir)!=0){
      strcpy(tmp,dir);
      strcat(tmp,namei);
      strcpy(namei,tmp);
      strcpy(tmp,dir);
      strcat(tmp,nameo);
      strcpy(nameo,tmp);
      strcpy(tmp,dir);
      strcat(tmp,padsfile);
      strcpy(padsfile,tmp);
    }
    printf("input file %s\n",namei);
    printf("output file %s\n",nameo);
    printf("pads file %s\n\n",padsfile);
}
