pro plotAPO1,datafile1,psfile,bw,notitle


COMMON COLORS, R_ORIG, G_ORIG, B_ORIG, R_CURR, G_CURR, B_CURR
loadct,0
ps=0

!p.multi=[0,4,2]

if n_elements(bw) eq 0 then bw=0
if n_elements(notitle) eq 0 then notitle=0

red=  [0  ,255,255,0  ,0  ,200,0  , 180]
green=[0  ,255,0  ,0  ,255,0  ,255, 180]
blue =[0  ,255,0  ,255,0  ,200,255, 180]
icol=7 ; gris pour les zones interdites

if notitle eq 1 then begin

  l0=28.
  h0=6.5
  dx1=0.04
  dy1=0.1
  dx2=0.005
  l=(1-dx1-dx2)/4.6
  h=l*l0/h0
  dx=(1-dx1-dx2-4*l)/3.
  posplot=fltarr(4,4)
  for i=0,3 do posplot(*,i)=[dx1+i*(l+dx),dy1,dx1+i*(l+dx)+l,dy1+h]

endif else begin

  l0=28.
  h0=9.
  dx1=0.04
  dy1=0.07
  dx2=0.005
  l=(1-dx1-dx2)/4.6
  h=l*l0/h0
  dx=(1-dx1-dx2-4*l)/3.
  posplot=fltarr(4,4)
  for i=0,3 do posplot(*,i)=[dx1+i*(l+dx),dy1,dx1+i*(l+dx)+l,dy1+h]

endelse

for i=0,3 do print,posplot(*,i)

!X.MINOR= -1.
!y.MINOR= -1.
!p.charsize=1.2
!p.title=''


if n_elements(psfile) ne 0 then begin
   ps=1
  !P.multi=[0,4,2]
  !p.thick=5
  !x.thick=5
  !y.thick=5
  set_plot,'ps';,/interpolate
    !x.ticks=0 & !x.tickname=''
   !y.ticks=0 & !y.tickname=''	
   !y.margin=[0.5,0.]
  device,filename=psfile,/landscape,ysize=h0,xsize=l0, $
	xoffset=2.,yoffset=29.,$
      /color, BITS=8
  print,'plot in '+psfile
  if bw eq 1 then begin
   	red=  [0  ,255,0  ,90,160,200,0  , 180]
  	green=[0  ,255,0  ,90,160,0  ,255, 180]
  	blue =[0  ,255,0  ,90,160,200,255, 180]
	endif
  endif else begin
  !p.thick=2
  !x.thick=1
  !y.thick=1	
endelse
TVLCT, RED, GREEN, BLUE

readdata,na,nconf,ncom,nvisi,lat0,opac,dec,vha0,vintime,dha, $
        vdmax,tol,dmaxmod,diam,vdmin, $
        dminmod,radmask,radmin,dptmax, $
        mapname,map,dxa,dya,nxm,nym,xc,yc,fwhm,plotonmap, $
        xx,yy,fixedant,datafile1

nvisi2=na*(na-1)*total(vintime/dha)
if nvisi2 ne nvisi then begin
	print,'=========================================='
	print,"WARNING: the number of visi does not match"
	print,"         the integration time and sampling rate!!!"
	if nconf eq 1 then begin
		dha=vintime[0]/(nvisi/(na*(na-1)))
		print,'correction made for 1 configuration'
	endif
	print,'=========================================='
endif
	

xx=xx/1000.
yy=yy/1000.
xc=xc/1000.
yc=yc/1000.
dxa=dxa/1000.
dya=dya/1000.
diam=diam/1000.
fwhm=fwhm/1000.
vdmax=vdmax/1000.
vdmin=vdmin/1000.
dminmod=dminmod/1000.
dmaxmod=dmaxmod/1000.
radmask=radmask/1000.

;diam=80
vpts=fltarr(nconf)
for i=0,nconf-1 do $
	if vintime[i] gt dha then begin
	    for i=0,nconf-1 do begin
		tmp=abs(vintime[i]/dha- round(vintime[i]/dha)) 
		if tmp lt 0.01 then vpts[i]=round(vintime[i]/dha)  $
	 	  else  vpts[i]=fix(vintime[i]/dha) 
	   endfor
	endif else vpts[i]=1
print,'vpts=',vpts

uvcol=intarr(nvisi)
dmax=max(vdmax)*tol
ifix=where(fixedant eq 1,nfix)
if radmin ne 0. then radmin2=radmin-diam/2. else radmin2=0.
print,'radmin2=',radmin2
t=findgen(21)*2*!pi/20.
xcirc=diam/2.*cos(t(*))
ycirc=diam/2.*sin(t(*))
USERSYM, xcirc/(4*diam), ycirc/(4*diam),/fill
t=findgen(101)*2*!pi/100.
xcirc2=radmin2*cos(t(*))
ycirc2=radmin2*sin(t(*))


ds=!pi*(dmax)^2/float(nvisi)
dl=sqrt(ds)

getallvisi,xx,yy,na,nconf,ncom,nvisi,lat0,opac,dec,dha,vpts,vintime,vha0, $
     uvf,uvant,uvwght,uvhour


;xx2=xx/1000.
;yy2=yy/1000.
maxx=max(xx)
maxy=max(yy)
minx=min(xx)
miny=min(yy)
d=max([maxx-minx,maxy-miny])/2.
dd=0.05*d
if dd lt diam then dd=diam


;xx=[0.,0.1,20.] &  yy=[-200.,0.,0.]

if notitle eq 0 then begin
  !p.title='!17 ANTENNA POSITIONS'
endif
if diam lt dmax/40. then plotnodata=0 else plotnodata=1
if plotonmap ne 1 then begin
    plot,xx,yy,psym=1,xrange=minx+(maxx-minx)/2.+[-d-dd,d+dd], $
          yrange=miny+(maxy-miny)/2.+[-d-dd,d+dd],/xstyle,/ystyle,$
          xtitle='X (km)',ytitle='Y (km)', $
          position=posplot(*,0),nodata=plotnodata
endif else begin
    xmap=(findgen(nxm)*dxa)-xc
    ymap=(findgen(nym)*dya)-yc
    xmaprange=[min(xmap),max(xmap)]
    ymaprange=[min(ymap),max(ymap)]
    print,'xc,yc=',xc,yc
    contour,map,xmap,ymap,nlevel=1,/fill,c_color=icol, $
       xtitle='X (km)',ytitle='Y (km)',position=posplot(*,0), $
      xrange=xmaprange, yrange=ymaprange,/xstyle,/ystyle,thick=0.5
endelse
if bw ne 1  then loadct,13 else loadct,0
TVLCT, RED, GREEN, BLUE
for i=0,nconf-1 do begin
   if i eq 0 then begin
     for j=0,na-ncom-1 do begin
         polyfill,xx(j)+xcirc,yy(j)+ycirc,/clip, $
                  color=2
         ind=where(uvant(0,*) eq j)
         uvcol(ind)=2
         ind=where(uvant(1,*) eq j)
         uvcol(ind)=2
     endfor
   endif else if i eq nconf-1 then begin
      for j=i*(na-ncom)+ncom,(i+1)*(na-ncom)+ncom-1 do begin
         ind=where(uvant(0,*) eq j)
         uvcol(ind)=2+i
         ind=where(uvant(1,*) eq j)
         uvcol(ind)=2+i
         polyfill,xx(j)+xcirc,yy(j)+ycirc,/clip,color=2+i
      endfor
   endif else begin
      for j=i*(na-ncom)+ncom,(i+1)*(na-ncom)-1 do begin
         ind=where(uvant(0,*) eq j)
         uvcol(ind)=2+i
         ind=where(uvant(1,*) eq j)
         uvcol(ind)=2+i
         polyfill,xx(j)+xcirc,yy(j)+ycirc,/clip,color=2+i
      endfor
   endelse
   if i lt nconf-1 then begin
      for j=(i+1)*(na-ncom),(i+1)*(na-ncom)+ncom-1 do begin
         ind=where(uvant(0,*) eq j)
         uvcol(ind)=2+i
         ind=where(uvant(1,*) eq j)
         uvcol(ind)=2+i
         polyfill,xx(j)+xcirc,yy(j)+ycirc,/clip,color=5+i
      endfor
   endif 
endfor

;for i=0,nfix-1 do polyfill,xx(ifix(i))+xcirc,yy(ifix(i))+ycirc,/clip
plots,xcirc2,ycirc2,/clip

uvmax=max(uvf(*,*))
uvmin=min(uvf(*,*))
dduv=0.05*(uvmax-uvmin)
density=lonarr(128,128)
uvi=round(uvf(0,*)*64/((uvmax-uvmin)/2.+dduv))+64+ $
   (round(uvf(1,*)*64/((uvmax-uvmin)/2.+dduv))+64)*128
density=histogram(uvi,input=density,min=0,max=128*128-1)

if nvisi gt 5000. then begin
  if notitle eq 0 then begin
    !p.title='DENSITY OF VISIBILITIES'
  endif
  if (ps eq 1)  then begin
    ;if bw eq 0 then loadct,13 else loadct,0
    for i=0,255 do begin
      r_curr(i)=r_curr(255-i)
      b_curr(i)=b_curr(255-i)
      g_curr(i)=g_curr(255-i)
    endfor	
    r_curr[0]=255
    b_curr[0]=255
    g_curr[0]=255
    TVLCT, r_curr, g_curr, b_curr
    ind=where(density gt 0,ngt0)
    if ngt0 gt 0 then   density(ind)=density(ind)*254/max(density)+1
    ;density(WHERE(density EQ 0B)) = 255B
    tv,density,posplot(0,1)*l0,posplot(1,1)*h0, $
	 xsize=(posplot(2,1)-posplot(0,1))*l0,$
	 ysize=(posplot(3,1)-posplot(1,1))*h0,$
	/centimeters
    TVLCT, RED, GREEN, BLUE
  endif 
  if ps eq 0 then begin
    ;density = MIN_CURVE_SURF(density)
    density=smooth(density,3)
    CONTOUR, density,PATH_XY=xy, PATH_INFO=info, $
            /PATH_DATA_COORDS,nlevel=5,thick=0.5
  endif

  plot,uvf(0,0:1),uvf(1,0:1),psym=3,$
       xrange=[uvmin-dduv,uvmax+dduv], $
       yrange=[uvmin-dduv,uvmax+dduv],/xstyle,/ystyle,$
     xtitle='U.!4k!17 (km)',ytitle='V.!4k!17 (km)',$
     position=posplot(*,1),/nodata
  if ps eq 0 then begin
    ;ind=(findgen(128)-64)/64*(uvmax-uvmin+2*dduv)
    xy=(xy-64)*((uvmax-uvmin)/2+dduv)/64
    FOR I = 0, (N_ELEMENTS(info) - 1 ) DO BEGIN
      S = [INDGEN(info(I).N), 0]
      PLOTS, xy(*,INFO(I).OFFSET + S ),/clip ;Plot the closed paths.
    ENDFOR
  endif
endif else begin
  if notitle eq 0 then begin
    !p.title='VISIBILITIES'
  endif
  plot,uvf(0,0:1),uvf(1,0:1),psym=3,$
       xrange=[uvmin-dduv,uvmax+dduv], $
       yrange=[uvmin-dduv,uvmax+dduv],/xstyle,/ystyle,$
     xtitle='U.!4k!17 (km)',ytitle='V.!4k!17 (km)',$
     position=posplot(*,1),/nodata
  for i=0,2*nconf-1 do begin
    ind=where(uvcol eq 2+i,ncol)
    if ncol ne 0 then oplot,uvf(0,ind),uvf(1,ind),psym=8,color=2+i,THICK=2.
  endfor

endelse

;for i=0,2*nconf-1 do begin
; ind=where(uvcol eq 2+i,ncol)
; if ncol ne 0 then oplot,uvf(0,ind),uvf(1,ind),psym=8,color=2+i
;endfor

npr=fix(2*(dmax)/dl)
print,'npr=',npr
nx=npr+2 & ny=npr+2
;im=fltarr(nx,ny)
du=2.*dmax/float(npr)
dv=du
center=[0.,0.]
if dl gt dmax/50. then binsz=dl else binsz=dmax/50.
distri=fltarr(fix(nx*dl/binsz)/2.+1)
distrirad,uvf,uvwght,center,ds,binsz,distri
szdistri=(size(distri,/dimensions))(0)
distri1=distri
;print,distri
dt=!pi/float(npr/4)
if dt lt !pi/50 then dt=!pi/50
tmin=0
tmax=!pi
distria=fltarr(fix(!pi/dt)+1)
distriang,uvf,uvwght,center,dt,tmin,tmax,dmax,radmask,ds,distria
distri1a=distria

mdistri=fltarr(nconf,(size(distri1,/dimensions))(0))
mdistria=fltarr(nconf,(size(distri1a,/dimensions))(0))
ivisi0=0
for iconf=0,nconf-1 do begin
   ivisi1=ivisi0+na*(na-1)/2*vpts(iconf)-1
   distrirad,uvf(*,ivisi0:ivisi1),uvwght(ivisi0:ivisi1),center,ds,binsz,distri
   szd=(size(distri,/dimensions))(0)
   mdistri(iconf,0:szd-1)=distri*2.

   distriang,uvf(*,ivisi0:ivisi1),uvwght(ivisi0:ivisi1), $
            center,dt,tmin,tmax,dmax,radmask,ds,distria
   szd=(size(distria,/dimensions))(0)
   mdistria(iconf,0:szd-1)=distria
   distriang,uvf(*,long(nvisi/2+ivisi0):long(nvisi/2+ivisi1)), $
             uvwght(long(nvisi/2+ivisi0):long(nvisi/2+ivisi1)), $
             center,dt,tmin,tmax,dmax,radmask,ds,distria
   szd=(size(distria,/dimensions))(0)
   mdistria(iconf,0:szd-1)= mdistria(iconf,0:szd-1)+ distria
   ivisi0=ivisi1+1
endfor

ni=fix((2*!pi)/dt)+1
nj=fix(dmax/binsz)+2

normf=double(nvisi)/getnbvisi(dminmod,dmaxmod,0.,2*!pi,1.,fwhm)
print,'fwhm=',fwhm,'normf=',normf
distrim=fltarr(nj)
for j=0,nj-1 do begin
    dsurf=!pi*(2.*j+1)*binsz^2
    distrim(j)= $
      getnbvisi(j*binsz,(j+1)*binsz,0.,2.*!pi,normf,fwhm)*ds/dsurf
endfor
ni=fix((tmax-tmin)/dt)+1
distrima=fltarr(ni)
for i=0,ni-1 do begin
    dsurf=dt/2.*((dmax)^2-(radmask)^2)
    distrima(i)= $
      getnbvisi(radmask,dmax,tmin+i*dt,tmin+(i+1.)*dt,normf,fwhm)*ds/dsurf
endfor

uvfi=uvf

if notitle eq 0 then begin
   !p.title='RADIAL PROFILE'
endif
x=indgen(szdistri)*binsz+binsz/2.
xrange1=[0,1.05*dmax] & yrange1=[0,1.05*max(distri1)]
plot,x,distri1,xrange=xrange1,yrange=yrange1, $
             /xstyle,/ystyle,$
     xtitle='RADIUS (km)',$
       ytitle='DENSITY !15D/D!17!I0!N',$ ;!4r!17/!4r!17!I0!N', $
        position=posplot(*,2),psym=10
oplot,x,distrim,linestyle=2
;plots,xrange1,[ds/144.,ds/144.]
for i=0,nconf-1 do oplot,x,mdistri(i,*),color=i+2,psym=10
oplot,[radmask,radmask],yrange1,linestyle=3
xyouts,0.62,0.6,'FWHM='+string(format='((f6.2))',fwhm),/norm

t=(indgen(fix(!pi/dt)+1)+0.5)*dt*180./!pi
yrangea=[0.,max([distri1a,distri1a])]

if notitle eq 0 then begin
   !p.title='AZIMUTHAL PROFILE'
endif
plot,t,distri1a,xrange=[0,180],yrange=yrangea,/xstyle,/ystyle,$
     xtitle='AZIMUTH (deg)',$
      ytitle='DENSITY  !15D/D!17!I0!N',$ ;!4r!17/!4r!17!I0!N', $
      position=posplot(*,3),psym=10
for i=0,nconf-1 do oplot,t,mdistria(i,*),color=i+2,psym=10
;oplot,t,total(mdistria,1)
oplot,t,distrima,linestyle=2


;pause='' & read,pause
if notitle eq 0 then begin
  !p.charsize=1.
  ;y0=offploty1+(2*dploty+py)
  y0=dy1+h
  dymax=1-y0
  dy=dymax/6.
  s=string(format='((f5.1)," deg")',lat0*180./!pi)
  xyouts,0.05,y0+3*dy,' SITE LAT. = '+s,/norm 
  s=string(format='((f5.1)," deg")',dec*180./!pi)
  xyouts,0.05,y0+2*dy,' SOURCE DEC. = '+s,/norm
  s=string(format='((f5.2)," h")',dha)
  xyouts,0.05,y0+1*dy,' SAMPLING INT. = '+s,/norm
  xyouts,0.3,y0+3*dy,strtrim(fix(na),1)+' ANTENNAS',/norm
  xyouts,0.3,y0+2*dy,strtrim(fix(nconf),1)+' CONFIGURATIONS',/norm
  xyouts,0.3,y0+1*dy,strtrim(fix(ncom),1)+' SHARED ANT.',/norm
  dy=dymax/float(nconf+3)
  for i=0,nconf-1 do begin
    s=string(format='("!3[!17",(f6.1),", " ,(f6.1),"!3]!17 km")',vdmin(i),vdmax(i))
    xyouts,0.5,y0+(nconf-i)*dy,'BL'+strtrim(i+1,1)+' = '+s,/norm,color=i+2
    s=string(format='("!3[!17",(f5.2),", ",(f5.2),"!3]!17 h")',vha0(i),vha0(i)+vintime(i))
    xyouts,0.73,y0+(nconf-i)*dy,'HA'+strtrim(i+1,1)+' = '+s,/norm,color=i+2
; s=string(format='((f5.2)," h")',vha0(i))
; xyouts,0.8,y0+(nconf-i)*dy,'HA'+strtrim(i+1,1)+' = '+s,/norm,color=i+2
 endfor
endif

;density(WHERE(density EQ 0B)) = 255B



if n_elements(psfile) gt 0 then begin
  device,/close
  set_plot,'x'
endif
;d=sqrt(uvf(0,*)^2+uvf(1,*)^2)
;print,min(d)
;pause='' & read,pause

end

