#include "APO.h"

#define PI 3.14159
#define OBSDURMAX 8.
#define BMIN 200.
#define NCONFI 3 // # of config for each wavelength

#define ALPHA1 2.
#define BETA1 1.
#define GAMMA1 10.
#define LAMBDA1 1.e-3

#define ALPHA2 2.
#define BETA2 1.
#define GAMMA2 10.
#define LAMBDA2 3.e-3 // must be > LAMBDA1
/*
*/

Instrume alma;
Obs obs1;
Transf transf1;
Site Chaj;
Model mod1;
Configfile filei;

main(int argc, char **argv){

  int i, ok=1, iconfig=0, na;
  float Bmax1, Bmax2, diam, dB, cst;
  float Bl1,reso1, Bl2, reso2;
  float tab[2*NCONFI][6];
  char ScGoalsfile[MAXSTRING];
  FILE *fp;

  filei=argv[1];
  sprintf(ScGoalsfile,"%s",argv[2]);
  filei.read(&alma, &Chaj, &obs1, &mod1);

  cst=2.*sqrt(log(10)/10.*log(2.))/PI;

  na=alma.getna();
  diam=alma.getdiam(0);
  Bmax2=na*(na-1)*ALPHA2*diam*OBSDURMAX/(48.*1.44);
  printf("Bmax2=%f\n",Bmax2);
  Bmax1=Bmax2*LAMBDA1/LAMBDA2;
  dB=(Bmax1-BMIN)/(NCONFI-1);
  for(i=0;i<NCONFI;i++){
    Bl1=BMIN+i*dB;
    reso1=cst*sqrt(GAMMA1)*LAMBDA1*180*3600/(PI* BETA1 * Bl1);
    tab[i][0]=Bl1;
    tab[i][1]=ALPHA1;
    tab[i][2]=BETA1;
    tab[i][3]=GAMMA1;
    tab[i][4]=reso1;
    tab[i][5]=LAMBDA1/1.e-3;

    Bl2=LAMBDA2/LAMBDA1*Bl1;
    reso2=cst*sqrt(GAMMA2)*LAMBDA2*180*3600/(PI*  BETA2 *Bl2);
    tab[NCONFI+i][0]=Bl2;
    tab[NCONFI+i][1]=ALPHA2;
    tab[NCONFI+i][2]=BETA2;
    tab[NCONFI+i][3]=GAMMA2;
    tab[NCONFI+i][4]=reso2;
    tab[NCONFI+i][5]=LAMBDA2/1.e-3;
    printf("Bl1=%f reso1=%f Bl2=%f reso2=%f\n", 
	   Bl1, reso1, Bl2, reso2);
  }
  //qsort(tab,2*NCONFI,sizeof(float *),compvec);
  if((fp=fopen(ScGoalsfile,"w")) == NULL){
    printf("ERROR: cannot open file %s\n",ScGoalsfile);            
    exit(1);
  }  
  fprintf(fp,"! alpha beta gamma(dB) dtheta(arcsec) lambda(mm)\n");
  for(i=0;i<2*NCONFI;i++){
  
    fprintf(fp,"%-3.1f %-3.1f %-4.1f %-7.3e %-3.1f\n",
	   tab[i][1],tab[i][2],tab[i][3],tab[i][4],tab[i][5],tab[i][6]);
  }
  fclose(fp);

}

