
#include "APO.h"
#include <string.h>
#define ngrids 7

APO vapo[ngrids];


void APOf(char *namei, char *nameo);

/*==========================================*/


void main(){

  int i,j;
  char s[15],s2[5];
  char namei[40], nameo[40];

  printf("----Start multioptimize------ \n");

  for(j=0;j<7;j++){
    if(j==0) sprintf(s2,"%s","f1_");
    if(j==1) sprintf(s2,"%s","f12_");
    if(j==2) sprintf(s2,"%s","f14_");
    if(j==3) sprintf(s2,"%s","f16_");
    if(j==4) sprintf(s2,"%s","f18_");
    if(j==5) sprintf(s2,"%s","f2_");
    if(j==6) sprintf(s2,"%s","f");
    for(i=0;i<10;i++){  
      sprintf(s,"%d",i);
      sprintf(namei,"%s%s","config/",s2);
      strcat(namei,s);
      strcpy(nameo,namei);
      strcat(nameo,"out");
      sprintf(s,"%s",".data");
      strcat(namei,s);
      strcat(nameo,s);
      printf("namei=%s nameo=%s\n",namei,nameo);

      APOf(namei, nameo);
    }
  }
  printf("----End of main------ \n");
}

/*==========================================*/

void APOf(char *namei, char *nameo){
 

  Instrume alma;
  Obs obs1;
  Site Chaj;
  Grid vgrid[ngrids];
  Model mod1;
  Datafile filei, fileo;
  int i,j,k,l,iter,niter, natot;
  int test1,test2;
  char pause;
  float fa0,fa,dptacc,fwhm;
  float gridrmax, gridrmin, gridsz0;
  char *stdname="stdev.data";
  time_t rtime;
  FILE *fp;
  float stdev,integr;
  // int ngrids=7;

  rtime=time(NULL);
  if((fp=fopen(stdname,"w")) == NULL){
    printf("ERROR: cannot open file %s\n",stdname);
    exit(1);
  }
  filei=namei;
  fileo=nameo;

  filei.read(&alma, &Chaj, &obs1, &mod1);
  //scanf("%c",&pause);
  alma.print();
  Chaj.print();

  natot=alma.getnatot();
  gridrmax=alma.getdmax();
  fwhm=mod1.getfwhm()/gridrmax;
  printf("gridrmax=%f\n",gridrmax);
  printf("fwhm=%f\n",fwhm);
  fa0=0.003;
  if(fwhm>1){
    if(fwhm<1.8) fa0/=(5*(pow(fwhm,1.4)-0.8));
    else fa0/=(5*(pow(1.8,1.4)-0.8));
  }
  printf("fa0=%f\n",fa0);
  // scanf("%c",&pause);
  dptacc=0.5;   niter=4;
  gridrmin=15.; gridsz0=6;
  for(i=0;i<ngrids;i++){
    vgrid[i].set(gridsz0+i, gridrmin,gridrmax, &mod1);
    //    vgrid[i].print();
  };  

  for(i=0;i<ngrids;i++) vapo[i].set(&alma, &obs1, &Chaj, vgrid+i);

  for(i=0;i<ngrids;i++) {
    stdev=vapo[i].getstdev();
    fprintf(fp,"%-9.2f ",stdev);
  }
  fprintf(fp,"\n");
  niter=20;
  for(k=0;k<niter;k++) {
    printf("k=%d\n",k);
    if(k==0) fa=fa0;
    else fa=3*fa0;
    if(k>2) fa=7*fa0;
    if(k>10) fa=5*fa0;
    //    if(k>niter-5) fa=5*fa0;
    if(k>niter-3) fa=3*fa0;
    optimize(vapo,ngrids,fa,dptacc);
    for(i=0;i<ngrids;i++) {
      stdev=vapo[i].getstdev();
      fprintf(fp,"%-9.2f ",stdev);
    }
    fprintf(fp,"\n");
  }
  fileo.write(&alma, &Chaj, &obs1, &mod1);
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
  fclose(fp);
}


/*==========================================*/

