
#include "APO.h"
#include <string.h>
#define ngrids 7

APO vapo[ngrids];


/*==========================================*/


void main(int argc, char **argv){

  Instrume alma;
  Obs obs1;
  Transf transf1;
  Site Chaj;
  Grid vgrid[ngrids];
  Model mod1;
  Configfile filei, fileo;
  int i,j,k,l,iter,niter, natot;
  int test1,test2;
  char pause;
  float fa0,fa,dptacc;
  float gridrmax, gridrmin, dmax, gridsz0,fwhm;
  char *stdname="stdev.data",s[15];
  char namei[40], nameo[40];
  time_t rtime;
  FILE *fp;
  float stdev,integr;
  // int ngrids=7;


  printf("----Start of main------ \n");

  rtime=time(NULL);
  if((fp=fopen(stdname,"w")) == NULL){
    printf("ERROR: cannot open file %s\n",stdname);
    exit(1);
  }
  sprintf(namei,"%s",argv[1]);
  sprintf(nameo,"%s",argv[2]);
  filei=namei;
  fileo=nameo;
  filei.read(&alma, &Chaj, &obs1, &mod1);
  alma.print();
  //alma.sort();
  //alma.print();
  //fileo.write(&alma, &Chaj, &obs1, &mod1);
  scanf("%c",&pause);
  //alma.print();
  //Chaj.print();

  natot=alma.getnatot();
  dmax=alma.getdmax();

  fwhm=mod1.getfwhm()/dmax;
  printf("fwhm=%f\n",fwhm);
  fa0=0.003;
  if(fwhm>1){
    if(fwhm<1.8) fa0/=(5*(pow(fwhm,1.4)-0.8));
    else fa0/=(5*(pow(1.8,1.4)-0.8));
  }
  printf("fa0=%f\n",fa0);
  dptacc=1.; 

  gridrmax=mod1.getdmax();
  gridrmin=mod1.getdmin();
  gridsz0=6;
  printf("gridrmax=%f\n",gridrmax);
  for(i=0;i<ngrids;i++){
    vgrid[i].set(gridsz0+i, gridrmin,gridrmax, &mod1);
    printf("grid %d set\n",i);
    vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
  }

  transf1.setshadow(-73.);

  //correct(vapo,ngrids,dptacc,0);
  correct(vapo,ngrids,dptacc);

  //fileo.write(&alma, &Chaj, &obs1, &mod1);
  //vapo[0].optimize(fa0,dptacc);
  scanf("%c",&pause);
  for(i=0;i<ngrids;i++) {
    stdev=vapo[i].getstdev();
    fprintf(fp,"%-9.2f ",stdev);
  }
  fprintf(fp,"\n");
  niter=40;
  for(k=0;k<niter;k++) {
    printf("k=%d\n",k);
    if(k==0) fa=fa0;
    else fa=3*fa0;
    if(k>2) fa=7*fa0;
    if(k>10) fa=5*fa0;
    //    if(k>niter-5) fa=5*fa0;
    if(k>niter-3) fa=3*fa0;
    optimize(vapo,ngrids,fa,dptacc);
    if(k<niter-3) shake(vapo,ngrids,dptacc);

    for(i=0;i<ngrids;i++) {
      stdev=vapo[i].getstdev();
      fprintf(fp,"%-9.2f ",stdev);
    }
    fprintf(fp,"\n");
  }
  fileo.write(&alma, &Chaj, &obs1, &mod1);
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
  fclose(fp);
}

