#include "APO.h"

#define NGRIDS 7
#define NCONFIG 6

APO vapo[NGRIDS];
Grid vgrid[NGRIDS];

Instrume alma;
Obs obs1;
Transf transf1;
Site Chaj;
Model mod1;
Configfile filei, fileo;
Padslist pads;


/*==========================================*/


void main(){

  int i,j,k,l,iter,niter, iconfig,idec, natot,ok;
  int test1,test2;
  int nloaded, nloadmax;
  char pause;
  float fa0,fa,dptacc;
  float bsl0, gridrmax0, gridrmin0, gridsz0, diam, obsdurmax;
  float bsl, gridrmax, gridrmin, fwhm;
  float alpha, obsdur, dt, hamin;
  float vdec[3]={-6,-47,24};

  char s[15];
  char namei[MAXSTRING], nameo[MAXSTRING], logfile[MAXSTRING]; 
  char namepads[MAXSTRING], dir[MAXSTRING], ScGoalsFile[MAXSTRING];
  FILE *logfp;  
  time_t now, starttime;
  time_t rtime;

  printf("----Start of main------ \n");
  
  rtime=time(NULL);
  gridsz0=6;
  dptacc=3.; 
  nloadmax=3;
  obsdurmax=8.0;
  sprintf(dir,"%s","config/array10dB_3dec/");
  sprintf(namei,"%s%s",dir,"array1.data");
  sprintf(namepads,"%s%s",dir,"arraypads.data");
  sprintf(ScGoalsFile,"%s%s",dir,"ScGoals.data");
  sprintf(logfile,"%s%s",dir,"apolog");

  if((logfp=fopen(logfile,"a")) == NULL){
    printf("ERROR: cannot open file %s\n",logfile);            
    exit(1);
  }          
  now=time(NULL);
  fprintf(logfp,"%s Starting array optimization \n",ctime(&now));
  fprintf(logfp,"   number of configurations=%d\n",NCONFIG);
  fprintf(logfp,"   number of declinations=%d\n",3);
  fprintf(logfp,"   maximum allowed observation duration %-5.2f\n",obsdurmax);
  fprintf(logfp,"   The Scientific goals are defined in=%s  \n",ScGoalsFile);
  fprintf(logfp,"   The pads positions are written in=%s  \n",namepads);
  fprintf(logfp,"   The first config is in namei=%s  \n",namei);
  fclose(logfp);

  filei=namei;
  pads=namepads;
  pads.setnconf((NCONFIG-1)*3+1);
  filei.read(&alma, &Chaj, &obs1, &mod1);
  alma.print();
  alma.addants2pads(&pads,0);
  pads.print();
  scanf("%c",&pause);

  natot=alma.getnatot();
  bsl0=alma.getdmax();
  diam=alma.getdiam(0);
  gridrmax0=mod1.getdmax();
  gridrmin0=mod1.getdmin();


  transf1.set(&obs1, &Chaj);

  scanf("%c",&pause);
  for(idec=0;idec<3;idec++){
    for(iconfig=1;iconfig<NCONFIG;iconfig++){
      sprintf(nameo,"%s%s",dir,"array");
      sprintf(s,"%d_%d%s",iconfig+1,idec+1,".data");
      strcat(nameo,s);
      printf("outputfile=%s\n",nameo);
      fileo=nameo;
      ok=alma.getBSL_FWHM_ObsDur(obsdurmax, ScGoalsFile, iconfig, 
				 &bsl, &fwhm, &obsdur);
      
      if((logfp=fopen(logfile,"a")) == NULL){
	printf("ERROR: cannot open file %s\n",logfile);            
	exit(1);
      } 	         
      now=time(NULL);
      fprintf(logfp,"%s nameo=%s  bsl=%-7.1f fwhm=%-7.1f obsdur=%-5.2f\n",
	      ctime(&now), nameo,  bsl, fwhm, obsdur);
      fclose(logfp);
      
      //    scanf("%c",&pause);
      
      if (obsdur>2) dt=obsdur/10.;
      else {
	if(obsdur>1) dt=obsdur/5.;
	else dt=0.15;
      }
      hamin=-obsdur/2;
      obs1.set(vdec[idec], &hamin, dt, &obsdur, 1); 
      
      gridrmax=bsl;
      printf("gridrmax=%f\n",gridrmax);
      gridrmin=gridrmin0;
      printf("gridrmin=%f\n",gridrmin);
      
      alma.setvdmax(&bsl,1);
      mod1.set(fwhm, gridrmin, gridrmax);
      alma.random(&Chaj, &obs1, &mod1);
      
      // alma.print();
      //scanf("%c",&pause);
      
      for(i=0;i<NGRIDS;i++){
	vgrid[i].set(gridsz0+i, gridrmin,gridrmax, &mod1);
	printf("grid %d set\n",i);
	vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
      }
      
      correct(vapo,NGRIDS,dptacc);
      
      
      alpha=fwhm/bsl;
      printf("alpha=%f\n",alpha);
      fa0=0.003;
      if(alpha>1){
	if(alpha<1.8) fa0/=(5*(pow(alpha,1.4)-0.8));
	else fa0/=(5*(pow(1.8,1.4)-0.8));
      }
      printf("fa0=%f\n",fa0);
      
      // scanf("%c",&pause);
      
      
      niter=30;
      for(k=0;k<niter;k++) {
	printf("k=%d\n",k);
	if(k==0) fa=fa0;
	else fa=3*fa0;
	if(k>2) fa=7*fa0;
	if(k>10) fa=5*fa0;
	//    if(k>niter-5) fa=5*fa0;
	if(k>niter-3 || k>20) fa=3*fa0;
	
	if(k>=6 && k<niter-4){
	  nloaded=alma.loadants2pads(&pads, nloadmax,
				     bsl, idec*(NCONFIG-1)+iconfig);
	  //	alma.print();
	  //scanf("%c",&pause);
	  if(nloaded>0){
	    for(i=0;i<NGRIDS;i++) 
	      vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
	    correct(vapo,NGRIDS,dptacc);
	  }
	}
	
	optimize(vapo,NGRIDS,fa,dptacc);
	//if(k<niter-3) shake(vapo,NGRIDS,dptacc);
      }
      fileo.write(&alma, &Chaj, &obs1, &mod1);
      alma.addants2pads(&pads, idec*(NCONFIG-1)+iconfig);
      pads.write();
      alma.freeants();
    }
    rtime=time(NULL)-rtime;
    printf("total runing time= %ld sec\n",rtime);
    if((logfp=fopen(logfile,"a")) == NULL){
      printf("ERROR: cannot open file %s\n",logfile);            
      exit(1);
    }        
    fprintf(logfp,"time on this config=%-5.2f\n",rtime);
    fclose(logfp);
  }  
  now=time(NULL);
  if((logfp=fopen(logfile,"a")) == NULL){
    printf("ERROR: cannot open file %s\n",logfile);            
    exit(1);
  }   
  fprintf(logfp,"total time=%-5.2f\n",now-starttime);
  fprintf(logfp,"-------End of array optimization------ \n");
  fclose(logfp);
  printf("----End of main------ \n");
  
}
  
