#include "APO.h"

#define OFFSETX 627807.0
#define OFFSETY 7453229.0

Padslist pads;


//----------------------------------------------------------------------
//  Parameters that are set in getArgs()
//----------------------------------------------------------------------
void getArgs(int argc, char **argv);		// get command-line arguments

char dir[MAXSTRING], filename[MAXSTRING], outputfile[MAXSTRING];
//----------------------------------------------------------------------


void main(int argc, char **argv){


  getArgs(argc, argv);

  printf("filename=%s\n",filename);
  printf("outputfile=%s\n",outputfile);

  pads=filename;
  pads.read();
  pads.print();
  pads.offset(OFFSETX, OFFSETY);
  pads.write2(outputfile);
}

//----------------------------------------------------------------------

void getArgs(int argc, char **argv)
{
  char tmp[MAXSTRING];

    if (argc <= 1) {				// no arguments
  	cerr << "Usage:\n\n"
	<< "  pads2UTM [-d dir][-f filename] [-o outputfile]\n\n"
	<< "  where:\n"
	<< "    dir           is the name of the directory where are filename and outputfile\n"
	<< "    filename      is the name of the file containing the initial pads positions\n"
	<< "    outputfile    is the name of the file where to write the new pads positions\n";
	exit(0);
    }
    int i = 1;
    while (i < argc) {			      // read arguments
	if (!strcmp(argv[i], "-d")) {	      // -d option
	  sprintf(dir,"%s",argv[++i]);   // directory
	}
	if (!strcmp(argv[i], "-f")) {	      // -f option
	  sprintf(filename,"%s",argv[++i]);        // filename
	}
	if (!strcmp(argv[i], "-o")) {	      // -o option
	  sprintf(outputfile,"%s",argv[++i]);  // outputfile
	}
	i++;
    }
    if (strlen(filename)==0) {
	cerr << "-f option must be specified\n";
	exit(1);
    }
    if (strlen(outputfile)==0) {
	cerr << "-o option must be specified\n";
	exit(1);
    }
    if (strlen(dir)!=0){
      strcpy(tmp,dir);
      strcat(tmp,filename);
      strcpy(filename,tmp);
      strcpy(tmp,dir);
      strcat(tmp,outputfile);
      strcpy(outputfile,tmp);
    }
}

