
/*
 * reoptimize an array already optimized with optimizearray
 *
*/


#include "APO.h"
#define GRIDSZ0 6
#define NGRIDS0 7
#define NCONFIG 5
#define NITER 50
#define FA0 0.042
#define FF0 0.5
#define DPTACC0 2.0
#define NLOADMAX 1

APO vapo[NGRIDS0];
Grid vgrid[NGRIDS0];

Instrume alma;
Obs obs1;
Transf transf1;
Site Chaj;
Model mod1;
Configfile filei, fileo;
Padslist pads;
//----------------------------------------------------------------------
//  Parameters that are set in getArgs()
//----------------------------------------------------------------------
void getArgs(int argc, char **argv);		// get command-line arguments

char dir[MAXSTRING];

/*==========================================*/


void main(int argc, char **argv){

  int i,j,k,l,iter, iconfig,natot,ok;
  int test1,test2;
  int nloaded, withpauses, ngrids;
  char pause;
  float fa, dptacc, ff;
  float bsl, gridrmax, gridrmin;
  char s[15];
  char namei[MAXSTRING]; 
  char namepads[MAXSTRING];
  time_t now, rtime;

  printf("----Start of main------ \n");
  getArgs(argc, argv);
  rtime=time(NULL);
  withpauses=0;

  sprintf(namei,"%s%s",dir,"array1.data");
  sprintf(namepads,"%s%s",dir,"arraypads.data");

  filei=namei;
  filei.read(&alma, &Chaj, &obs1, &mod1);
  alma.print();
  pads=namepads;
  alma.addants2pads(&pads,0);
  pads.print();

  if(withpauses) scanf("%c",&pause);

  for(iconfig=1;iconfig<NCONFIG;iconfig++){

    sprintf(namei,"%s%s%d%s",dir,"array",iconfig+1,".data");
    filei=namei;
    fileo=namei;

    filei.read(&alma, &Chaj, &obs1, &mod1);
    transf1.set(&obs1, &Chaj);
    alma.print();
    natot=alma.getnatot();
    gridrmax=mod1.getdmax();
    gridrmin=mod1.getdmin();
    bsl=gridrmax;

    for(i=0;i<NGRIDS0;i++){
      vgrid[i].set(GRIDSZ0+i, gridrmin,gridrmax, &mod1);
      printf("grid %d set\n",i);
      vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
    }

    correct(vapo,NGRIDS0,DPTACC0);
    printf("FA0=%f\n",FA0);
    for(k=0 ; k<NITER ; k++) {
      printf("k=%d\n",k);
      fa=FA0/150;
      if(k>2) fa=FA0/80;
      if(k>3) fa=FA0/30;
      if(k>5) fa=FA0/10;
      if(k>7) fa=FA0/3;
      if(k>10) fa=FA0/1.5;
      if(k>13) fa=FA0;
      if(k>43) fa=FA0/1.2;
      if(k>NITER-3) fa=FA0/1.5;       
      
      dptacc=DPTACC0;
      if(k<10) dptacc=5*DPTACC0;
      if(k<20) dptacc=2*DPTACC0;

      //ff=FF0/2.5;      
      //if(k>26) ff=FF0/1.8;
      ff=FF0/1.5;
      if(k==31) ff=FF0;
      if(k==37) ff=FF0;
      //if(k>40) ff=FF0/3.;
      if(k>40) ff=FF0/2.;
      if(k>43) ff=FF0/4.;
      
      ngrids=NGRIDS0;
      if(k==NITER/2){
	for(i=0;i<ngrids;i++){
	  vgrid[i].set(GRIDSZ0+i+1, gridrmin,gridrmax, &mod1);
	  printf("grid %d set\n",i);
	  vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
	}
      }
      if(k==NITER-12){
	ngrids=NGRIDS0-2;
	for(i=0;i<ngrids;i++){
	  vgrid[i].set(GRIDSZ0+i+4, gridrmin,gridrmax, &mod1);
	  printf("grid %d set\n",i);
	  vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
	}
      }
      if(k>19 && k<NITER-3 && k%2==1){
	nloaded=alma.loadants2pads(&pads, NLOADMAX, bsl, ff, iconfig);
	//	alma.print();
	//scanf("%c",&pause);
	if(nloaded>0){
	  for(i=0;i<NGRIDS0;i++) 
	    vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
	  correct(vapo,NGRIDS0,DPTACC0);
	}
      }
      optimize(vapo,ngrids,fa,dptacc);
      if(k>10 && k<NITER-10) shake(vapo,ngrids,dptacc);
    }
    fileo.write(&alma, &Chaj, &obs1, &mod1);
    alma.addants2pads(&pads, iconfig);
    pads.write();
    alma.freeants();
  }
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
  printf("----End of main------ \n");
  
}

//----------------------------------------------------------------------

void getArgs(int argc, char **argv)
{
  char tmp[MAXSTRING];

    if (argc <= 1) {				// no arguments
  	cerr << "Usage:\n\n"
	<< "  optimizearray [-d dir]\n\n"
	<< "  where:\n"
	<< "    dir      is the name of the directory in which the required files are.\n"
	<< "              required files: \n"
	<< "               1. ScGoals.data which contains the scientific goals\n"
 	<< "               2. array1.data which contains the compact configuration\n";
	exit(0);
    }
    int i = 1;
    while (i < argc) {				// read arguments
	if (!strcmp(argv[i], "-d")) {	      // -d option
	  sprintf(dir,"%s",argv[++i]);        // directory
	}

	i++;
    }
    if (strlen(dir)==0) {
	cerr << "-d option must be specified\n";
	exit(1);
    }

}
